#
# Copyright (c) 2005, Fuji Xerox Co., Ltd.
# All rights reserved.
#

#Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

#1.Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#2.Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#3.Neither the name of the <Fuji Xerox Co., Ltd.> nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#i18N
#---- check locale with environment variable
set locale_alias_path  /usr/share/X11/locale

if {[file exists $locale_alias_path/locale.alias] != 1} {
    set locale_alias_path /usr/lib/X11/locale
}

proc conv_locale {alias} {
    global env envL locale_alias_path

    set language ""
    if { ( [lsearch $envL $alias] != -1 ) && ($env($alias) != "") } {
        if { $env($alias) == "C" } \
        then { set language "C" } \
        else { set language \
            [ exec awk "\$1 ~ /^$env($alias)$/ {print \$2}" \
                $locale_alias_path/locale.alias | head -c 2 ]
            if { $language == "" } {
                set language \
                [ exec awk "\$2 ~ /^$env($alias)$/ {print \$2}" \
                    $locale_alias_path/locale.alias | head -c 2 ]
            }
        }
    }
    return $language
}

#----     priority :  LC_ALL > LC_CTYPE > LC_MESSAGE > LANG > "C"
set envL   [ array names env L* ]
set locale [ conv_locale LC_ALL ]
if { $locale == "" } {
    set locale [ conv_locale LC_CTYPE ]
    if { $locale == "" } {
        set locale [ conv_locale LC_MESSAGES ]
        if { $locale == "" } {
            set locale [ conv_locale LANG ]
            if { $locale == "" } {
                if {[file exists /etc/default/locale/i18n] == 1} {
                    set locale [exec awk -F= "/^LANG/ {print \$2}" /etc/default/locale/i18n | sed s/\"//g | head -c 2]
                } elseif {[file exists /etc/sysconfig/i18n] == 1} {
                    set locale [exec awk -F= "/^LANG/ {print \$2}" /etc/sysconfig/i18n | sed s/\"//g | head -c 2]
                }
                if { $locale == "" } {
                    set locale "C"
                }
            }
        }
    }
}

